<?php
/**
 * Created by PhpStorm.
 * User: rafaelpickbrenne
 * Date: 23/06/14
 * Time: 12:28
 */

namespace Folha\Logic;

use Folha\Entities\FpaDirfmagnet;
use HCM\Util\DateUtil;

include_once "C:/workfolder/v_220/products/projects/hrm/public/bootstrap.php";

class Dirfmagnet {
    private $objDirfMagnet;
    private $nrCpfAnterior;    //Vinculo anterior. Usado para persistir automaticamente.
    private $idPrimeiraExec;    //Indica se é a primeira execução
    //Campos de registro
    private $nrdirfmagnet;
    private $nrorg;
    private $mescompetencia;
    private $idtpinscestrutu;
    private $cdinscestrut;
    private $dtadmissaovinc;
    private $idtiporegistro;
    private $dslinharegistro;
    private $nrvinculom;
    private $nrpessoarespons;
    private $idativo;
    private $dtinclusao;
    private $dtultatu;
    private $nrorginclusao;
    private $cdoperinclusao;
    private $nrorgultatu;
    private $cdoperultatu;
    private $nrprocesso;
    private $dsnaturezarend;
    private $vrtotalrend;
    private $vrtotalprev;
    private $vrtotalprevcomp;
    private $vrtotalpensao;
    private $vrtotimpretido;
    private $vrparcelaisenta;
    private $vrajudacusto;
    private $vrproventosapos;
    private $vrlucrdividendo;
    private $vrtitempresa;
    private $vrindenizacao;
    private $vrpecuniario;
    private $vr13salario;
    private $vroutrendtrexcl;
    private $vrqtdemes;
    private $vracumuladorend;
    private $vracumuladodesp;
    private $vracumuladocont;
    private $vracumuladopens;
    private $vracumuladoiret;
    private $vracumuladoisen;
    private $dsinformacompl;
    private $vrimpret13;    //5.2. Imposto sobre a renda retido na fonte sobre 13º salário
    private $nmpessoa;
    private $nrcpfpessoa;

    public function __construct($nrOrg, $dtCompetencia){
        $this->nrorg          = $nrOrg;
        $this->mescompetencia = $dtCompetencia;
        $this->nrCpfAnterior = -1;
        $this->idPrimeiraExec = true;   //Indica a primeira execução
        $this->nrprocesso     = 0;
    }

    private function deParaMag($Codigo, $IdRec, $Valor, $Valor13){    //De Para do código do valor X nome do campo no magnético
        switch($Codigo){
            case 'RTRT':
                if($IdRec == '3562|'){     //Código especial para a participação de lucros
                    $this->vroutrendtrexcl += $Valor;
                }else{                  //Demais códigos de receita vinculados ao tipo de vínculo
                    $this->vrtotalrend     += $Valor;   //3.1.
                    //$this->vr13salario     += $Valor13; //5.1.
                }
                break;
            case 'RTRT-INF':
                $this->vr13salario     += $Valor13; //5.1.
                break;
            case 'RTPO':
                $this->vrtotalprev     += $Valor;   //3.2. - Tanto os mensais e o 13º salário
                $this->vrtotalprev     += $Valor13; //3.2.
                break;
            case 'RTIRF':
                //$this->vracumuladoiret += $Valor;
                $this->vrtotimpretido  += $Valor;   //3.5.
                $this->vrimpret13      += $Valor13; //5.2. Imposto sobre a renda retido na fonte sobre 13º salário
                break;
            case 'RIAP':
                //$this->vracumuladoisen += $Valor; //6.6.
                $this->vrpecuniario    += $Valor;   //4.7. Outros (especificar)
                break;
            case 'RTPA':    //Verificar a incidência deste item
                $this->vrtotalpensao   += $Valor;
                break;
            case 'RIL96':   //Rendimentos Isentos Anuais - Lucros e dividendos pagos a partir de 1996
                //$this->vrlucrdividendo += $Valor; //campo 4.4., no relatório C44
                $this->vroutrendtrexcl += $Valor;   //campo 5.2. (o antigo 5.2. foi migrado para 5.3.)
                break;
            case 'RIIRP':   //Rendimentos isentos - Indenização por Rescisão de Contrato de trabalho, inclusive a título de PDV
                $this->vrindenizacao   += $Valor;   //campo 4.6. Indenizações por rescisão de contrato de trabalho, inclusive a por acidente de trabalho
                break;
            /*case 'INFORMAÇÕES COMPLEMENTARES':
                $this->dsinformacompl  += $Valor;
                break;*/
        }
    }

    private function deParaCodReceita($CodReceita){
        switch($CodReceita){
            case '0561|':
                $this->dsnaturezarend = 'Rendimentos do trabalho assalariado';
                break;
            case '0588|':
                $this->dsnaturezarend = 'Trabalho sem Vínculo Empregatício';
                break;
            case '3562|':
                $this->dsnaturezarend = 'Participação nos Lucros';
                break;
        }
    }

    public function qdeRegistros(/*$nrOrg, $dtCompetencia*/){    //Retorna a quantidade de registros do Mgnético
        $cont = 0;
        try{
            $where = "NRORG = ? AND MESCOMPETENCIA = TO_DATE('$this->mescompetencia', 'DD/MM/YYYY' )";
            $registros = \Folha\Entities\FpaDirfmagnet::getObjectsByWhere($where, array($this->nrorg));
            foreach ($registros as $item){
                $cont++;    //Contador de registros
            }
        } catch(\Exception $e) {
            throw new \Exception('Não foi possivel localizar registros da DIRF no magnético. O erro foi: '.$e->getMessage());
        }
        return $cont;
    }

    public function addRegCabecal($cdInscEstrut, $idTipoRegistro, $nrPessoaRespons, $idAtivo){
        $this->cdinscestrut    = $cdInscEstrut;
        $this->idtiporegistro  = $idTipoRegistro;
        $this->nrpessoarespons = $nrPessoaRespons;
        $this->idativo         = $idAtivo;
        $this->dtinclusao      = today();
        $this->idPrimeiraExec  = true;   //Indica a primeira execução já que um novo cabeçalho foi gereado
    }

    public function addRegVinculo($nrCpf, $nmpessoa, $dtAdmissao, $Codigo, $CodReceita, $Valor, $Valor13, $Registro, $Complemento){ //Função que adiciona dados do vínculo no magnético
        if($this->nrCpfAnterior != $nrCpf){    //Verifica se os dados são do mesmo vínculo ou de um novo
            $this->nrCpfAnterior = $nrCpf;     //...os dados são de um novo vínculo. Armazena o novo vínculo para conferir com a prózimna leva de dados
            if($this->idPrimeiraExec)   //Verifica se é primeira execução. Se for ele ignora esta iteração e não persistirá
            {
                $this->idPrimeiraExec = false;  //Indica para os próximos que não é mais a primeira execução
            } else {                    //Não é a primeira execção e houve 'troca' de vínculo, portanto deve persistir
                $this->setAllToObj();   //Seta o objeto magnético
                $this->persistir();     //Persiste os dados do vínculo anterior (já que um novo vínculo 'chegou')
                $this->zeraRegVinculo();    //Zera os registros do vínculo para a próxima inserção
            }
            $this->nrvinculom     = null;       //Fora de uso. A query não mais trabalha por nº de vínculo. O novo id é o cpf da pessoa
            $this->nrcpfpessoa    = $nrCpf;
            $this->nmpessoa       = $nmpessoa;
            $this->dtadmissaovinc = $dtAdmissao;
            $this->deParaMag($Codigo, $CodReceita, $Valor, $Valor13);
            $this->dslinharegistro = $Registro;
            $this->dsinformacompl  = $Complemento;
            //$this->nrprocesso++;        //Incremento do número do processo
            $this->deParaCodReceita($CodReceita);   //Insere a descrição da natureza do rendimento
        } else {
            $this->deParaMag($Codigo, $CodReceita, $Valor, $Valor13);
            $this->dslinharegistro = $Registro;
        }
    }

    public function fimAddRegVinculo(){    //Indica que chegou ao fim da adição de dados no magnético
        $this->setAllToObj();   //Seta o objeto magnético
        $this->persistir();     //Persiste os dados do último vínculo inserido.
        $this->zeraRegVinculo();    //Zera os registros do vínculo para a próxima inserção
    }

    public function excluirCompetencia(/*$nrOrg, $dtCompetencia*/){
        $cont = 0;
        try{
            $where = "NRORG = ? AND MESCOMPETENCIA = TO_DATE('$this->mescompetencia', 'DD/MM/YYYY' )";
            $registros = \Folha\Entities\FpaDirfmagnet::getObjectsByWhere($where, array($this->nrorg));
            foreach ($registros as $item){
                $item->delete();
                $cont++;        //Contador de registros deletados
            }
            \Setforms2\Shared\Registry::getEntityManager()->flush();
        } catch(\Exception $e) {
            throw new \Exception('Não foi possivel retroceder a DIRF no magnético. O erro foi: '.$e->getMessage());
        }
        return $cont;
    }

    private function setAllToObj(){ //Seta todos os registros no objeto DirfMagnet
        $this->objDirfMagnet = new FpaDirfmagnet();

        $this->nrdirfmagnet = \Geral\Util\NovoCodigo::geraCodigo($this->nrorg,'FPA_DIRFMAGNET'.$this->nrorg, 1, 22, true ); //Gera o novo código do magnético

        $this->objDirfMagnet->setNrdirfmagnet($this->nrdirfmagnet);
        $this->objDirfMagnet->setNrorg($this->nrorg);
        $this->objDirfMagnet->setMescompetencia($this->mescompetencia);
        $this->objDirfMagnet->setIdtpinscestrutu($this->idtpinscestrutu);
        $this->objDirfMagnet->setCdinscestrut($this->cdinscestrut);
        $this->objDirfMagnet->setDtadmissaovinc($this->dtadmissaovinc);
        $this->objDirfMagnet->setIdtiporegistro($this->idtiporegistro);
        $this->objDirfMagnet->setDslinharegistro($this->dslinharegistro);
        $this->objDirfMagnet->setNrvinculom($this->nrvinculom);
        $this->objDirfMagnet->setNrpessoarespons($this->nrpessoarespons);
        $this->objDirfMagnet->setIdativo($this->idativo);
        $this->objDirfMagnet->setDtinclusao($this->dtinclusao);
        $this->objDirfMagnet->setDtultatu($this->dtultatu);
        $this->objDirfMagnet->setNrorginclusao($this->nrorginclusao);
        $this->objDirfMagnet->setCdoperinclusao($this->cdoperinclusao);
        $this->objDirfMagnet->setNrorgultatu($this->nrorgultatu);
        $this->objDirfMagnet->setCdoperultatu($this->cdoperultatu);
        $this->objDirfMagnet->setNrprocesso($this->nrprocesso);
        $this->objDirfMagnet->setDsnaturezarend($this->dsnaturezarend);
        $this->objDirfMagnet->setVrtotalrend($this->vrtotalrend);
        $this->objDirfMagnet->setVrtotalprev($this->vrtotalprev);
        $this->objDirfMagnet->setVrtotalprevcomp($this->vrtotalprevcomp);
        $this->objDirfMagnet->setVrtotalpensao($this->vrtotalpensao);
        $this->objDirfMagnet->setVrtotimpretido($this->vrtotimpretido);
        $this->objDirfMagnet->setVrparcelaisenta($this->vrparcelaisenta);
        $this->objDirfMagnet->setVrajudacusto($this->vrajudacusto);
        $this->objDirfMagnet->setVrproventosapos($this->vrproventosapos);
        $this->objDirfMagnet->setVrlucrdividendo($this->vrlucrdividendo);
        $this->objDirfMagnet->setVrtitempresa($this->vrtitempresa);
        $this->objDirfMagnet->setVrindenizacao($this->vrindenizacao);
        $this->objDirfMagnet->setVrpecuniario($this->vrpecuniario);
        $this->objDirfMagnet->setVr13salario($this->vr13salario);
        $this->objDirfMagnet->setVroutrendtrexcl($this->vroutrendtrexcl);
        $this->objDirfMagnet->setVrqtdemes($this->vrqtdemes);
        $this->objDirfMagnet->setVracumuladorend($this->vracumuladorend);
        $this->objDirfMagnet->setVracumuladodesp($this->vracumuladodesp);
        $this->objDirfMagnet->setVracumuladocont($this->vracumuladocont);
        $this->objDirfMagnet->setVracumuladopens($this->vracumuladopens);
        $this->objDirfMagnet->setVracumuladoiret($this->vracumuladoiret);
        $this->objDirfMagnet->setVracumuladoisen($this->vracumuladoisen);
        $this->objDirfMagnet->setDsinformacompl($this->dsinformacompl);
        $this->objDirfMagnet->setVrimpret13($this->vrimpret13);
        $this->objDirfMagnet->setNmpessoa($this->nmpessoa);
        $this->objDirfMagnet->setNrcpfpessoa($this->nrcpfpessoa);
    }

    private function zeraRegCabecal(){
        $this->cdinscestrut    = null;
        $this->idtiporegistro  = null;
        $this->nrpessoarespons = null;
        $this->idativo         = null;
        //Deve ter os mesmo campos que foram 'setados' pelo addRegCabecal
    }

    private function zeraRegVinculo(){
        $this->dslinharegistro = null;

        $this->nrvinculom      = null;
        $this->dtadmissaovinc  = null;
        $this->vrtotalrend     = null;
        $this->vrtotalprev     = null;
        $this->vrtotalprevcomp = null;
        $this->vrtotalpensao   = null;
        $this->vrtotimpretido  = null;
        $this->vrparcelaisenta = null;
        $this->vrajudacusto    = null;
        $this->vrproventosapos = null;
        $this->vrlucrdividendo = null;
        $this->vrtitempresa    = null;
        $this->vrindenizacao   = null;
        $this->vrpecuniario    = null;
        $this->vr13salario     = null;
        $this->vroutrendtrexcl = null;
        $this->vrqtdemes       = null;
        $this->vracumuladorend = null;
        $this->vracumuladodesp = null;
        $this->vracumuladocont = null;
        $this->vracumuladopens = null;
        $this->vracumuladoiret = null;
        $this->vracumuladoisen = null;
        $this->dsinformacompl  = null;
        $this->vrimpret13      = null;
        $this->nmpessoa        = null;
        $this->nrcpfpessoa     = null;
    }

    //todo Fazer a inclusão de dados de auditoria?

    private function persistir(){
        try{
            //\Setforms2\Shared\Registry::getEntityManager()->beginTransaction();
            $this->objDirfMagnet->persist();    //Persiste os dados
            \Setforms2\Shared\Registry::getEntityManager()->flush();
            //\Setforms2\Shared\Registry::getEntityManager()->commit();
        } catch(\Exception $e) {
            throw new \Exception('Não foi possivel salvar a DIRF no magnético. O erro foi: '.$e->getMessage());
        }
    }
}