/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_CONTCORR                                                 */
/* Tabela : CONTCORR                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 03/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_CONTCORR'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_CONTCORR
GO

CREATE TRIGGER DTULTATU_CONTCORR
ON CONTCORR
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'CONTCORR', null, 'CDREDUCONT=' + CDREDUCONT + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE CONTCORR
      SET DTULTATUCCOR = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(CONTCORR.CDCONTCORR,0) = ISNULL(INSERTED.CDCONTCORR,0)) AND
            (ISNULL(CONTCORR.CDREDUCONT,0) = ISNULL(INSERTED.CDREDUCONT,0)) AND
            (ISNULL(CONTCORR.DSCONTCORR,0) = ISNULL(INSERTED.DSCONTCORR,0)) AND
            (ISNULL(CONTCORR.CDBANCO,0)    = ISNULL(INSERTED.CDBANCO,0))    AND
            (ISNULL(CONTCORR.CDAGENCIA,0)  = ISNULL(INSERTED.CDAGENCIA,0))  AND
            (ISNULL(CONTCORR.CDEMPRESA,0)  = ISNULL(INSERTED.CDEMPRESA,0)) ;
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_CONTCORR','5.07.015';
GO

