var Dfe26000_InflacaoInterna_Controller = function(ScreenService, ZhLayoutPreferences, General, templateManager, localStorageEngine, Dfe26000_InflacaoInterna_Service, ZhFilterPreferences) {

    //before apply filter
    this.changeCurrentRowBeforeFilter = function(widgetPopup, args) {
        var widget = templateManager.container.getWidget('dfe26000_inflacao_interna_grid');
        if (!widgetPopup) {
            args.e.preventDefault();
        }
        else {
            if (!this.validaNivel(widgetPopup.FILTER_ROW, args) && !this.compararDatas(widgetPopup.FILTER_ROW, args)) {
                if (widget.getField('DATAINICIAL').readOnly === false) {
                    var dataIni = moment(widgetPopup.FILTER_ROW.DATAINICIAL, 'DD/MM/YYYY');
                    var dataFin = moment(widgetPopup.FILTER_ROW.DATAFINAL, 'DD/MM/YYYY');
                    if (dataIni.isAfter(dataFin)) {
                        ScreenService.showMessage('A Data Inicial deve ser inferior a Data Final');
                        args.e.preventDefault();
                    }
                }
                else {
                    widgetPopup.FILTER_ROW.INIMES1 = moment(widgetPopup.FILTER_ROW.MES1, "MM/YYYY").startOf('month').format('DD/MM/YYYY');
                    widgetPopup.FILTER_ROW.FINMES1 = moment(widgetPopup.FILTER_ROW.MES1, "MM/YYYY").endOf('month').format('DD/MM/YYYY');
                    widgetPopup.FILTER_ROW.INIMES2 = moment(widgetPopup.FILTER_ROW.MES2, "MM/YYYY").startOf('month').format('DD/MM/YYYY');
                    widgetPopup.FILTER_ROW.FINMES2 = moment(widgetPopup.FILTER_ROW.MES2, "MM/YYYY").endOf('month').format('DD/MM/YYYY');
                }
                this.selectDataSourceByReport(widgetPopup);
            }
        }
    };

    //after apply filter
    this.buildDataSourceFilterAndGrid = function(widgetPopup, args) {
        var arrayIndex = [];
        var widget = templateManager.container.getWidget('dfe26000_inflacao_interna_grid');
        var field = widgetPopup.FILTER_ROW.CDOPERENTR;
        var mascara = getLocalVar('GER_CDPICTPROD');
        //corrige filtro versão nova

        if (!widget.dataSourceFilter.some(row => row.name == 'CDPRODFINAL')) {
            widget.dataSourceFilter.push({
                'name': "CDPRODFINAL",
                'operator': "=",
                'value': widgetPopup.FILTER_ROW.CDPRODFINAL
            });

        }
        else {
            //Atualiza valores CDPRODFINAL
            let row = widget.dataSourceFilter.filter(row => row.name == 'CDPRODFINAL');
            row[0].value = widgetPopup.FILTER_ROW.CDPRODFINAL;
        }

        if (!widget.dataSourceFilter.some(row => row.name == 'NMTIPOCUSTO')) {
            widget.dataSourceFilter.push({
                'name': "NMTIPOCUSTO",
                'operator': "=",
                'value': widgetPopup.FILTER_ROW.NMTIPOCUSTO
            });

        }
        else {
            //Atualiza valores NMTIPOCUSTO
            let row = widget.dataSourceFilter.filter(row => row.name == 'NMTIPOCUSTO');
            row[0].value = widgetPopup.FILTER_ROW.NMTIPOCUSTO;
        }

        if (!widget.dataSourceFilter.some(row => row.name == 'TIPOCUSTO')) {
            widget.dataSourceFilter.push({
                'name': "TIPOCUSTO",
                'operator': "=",
                'value': widgetPopup.FILTER_ROW.TIPOCUSTO
            });

        }
        else {
            let row = widget.dataSourceFilter.filter(row => row.name == 'TIPOCUSTO');
            row[0].value = widgetPopup.FILTER_ROW.TIPOCUSTO;

        }

        if (!widget.dataSourceFilter.some(row => row.name == 'CDPRODINI')) {
            widget.dataSourceFilter.push({
                'name': "CDPRODINI",
                'operator': "=",
                'value': widgetPopup.FILTER_ROW.CDPRODINI
            });

        }
        else {
            //Atualiza valores CDPRODINI
            let row = widget.dataSourceFilter.filter(row => row.name == 'CDPRODINI');
            row[0].value = widgetPopup.FILTER_ROW.CDPRODINI;
        }

        //Colocar z ao final do codigo do produto final , conforme o nuemro total de numeros da mascara da filial    
        for (var x = 0; x < widget.dataSourceFilter.length; x++) {
            if (widget.dataSourceFilter[x].name === 'CDPRODFINAL') {
                mascara = getLocalVar('GER_CDPICTPROD');
                mascara = mascara.split('.');
                var mascaraSemPonto = "";
                for (var index in mascara) {
                    mascaraSemPonto = mascaraSemPonto + mascara[index];
                }
                mascara = mascaraSemPonto.length;
                var tamanhoValue = widget.dataSourceFilter[x].value.length;
                mascara = mascara - tamanhoValue;
                var maximo = 'z';
                widget.dataSourceFilter[x].value = widget.dataSourceFilter[x].value + maximo.repeat(mascara);
                widgetPopup.FILTER_ROW.CDPRODFINAL = widget.dataSourceFilter[x].value;
            }
        }
        //Colocar a lista ou T no filtro de Operações
        if (field === 'Lista') {
            widget.dataSourceFilter.forEach(function(filter, index) {
                if (filter.name === 'CDOPERENTR' || filter.name === 'NMTIPOOPER') {
                    arrayIndex.push(index);
                }
            });
            this.buildDataSourceFilter(widget, arrayIndex);
            arrayIndex = [];
            var field2 = widgetPopup.FILTER_ROW.CDTIPOOPER;
            var string = '_' + field2.join('_') + '_';
            widget.dataSourceFilter.push({
                "name": "CDOPERENTR",
                "operator": "=",
                "value": string
            });
            widgetPopup.FILTER_ROW.CDOPERENTR = string;
            widget.filterData = Util.clone(widgetPopup.FILTER_ROW);
            widgetPopup.FILTER_ROW.CDOPERENTR = 'Lista';
        }
        else {
            widget.dataSourceFilter.forEach(function(filter, index) {
                if (filter.name === 'CDOPERENTR') {
                    filter.value = 'T';
                }
            });
            widgetPopup.FILTER_ROW.CDOPERENTR = 'T';
            widget.filterData = Util.clone(widgetPopup.FILTER_ROW);
            widgetPopup.FILTER_ROW.CDOPERENTR = 'Todos';
        }
        if (widgetPopup.FILTER_ROW.REPORT_NAME === 'Inflação Interna') {
            this.setShowOnlist(true, false, widget);
            let dtini = widget.dataSourceFilter.filter(row => row.name == 'DATAINICIAL');
            dtini[0].value = moment('01/' + widgetPopup.FILTER_ROW.MES1, 'DD/MM/YYYY').startOf('month').format('DD/MM/YYYY');

            let dtfim = widget.dataSourceFilter.filter(row => row.name == 'DATAFINAL');
            dtfim[0].value = moment('01/' + widgetPopup.FILTER_ROW.MES2, 'DD/MM/YYYY').endOf('month').format('DD/MM/YYYY');

            widget.dataSourceFilter.forEach(function(filter, index) {
                if (filter.name === 'CDGRUPFILI' || filter.name === 'REPORT_NAME' || filter.name === 'TAMNIVEL' || filter.name === 'INIMES1' || filter.name === 'FINMES1' || filter.name === 'INIMES2' || filter.name === 'FINMES2' || filter.name === 'MES1' || filter.name === 'MES2') {
                    arrayIndex.push(index);
                }
            });
        }
        else if (widgetPopup.FILTER_ROW.REPORT_NAME === 'Inflação Interna Consolidada') {
            //Campos do relatorio Inflação Interna Consolidada
            this.setShowOnListConsolidada(widget);
            widget.dataSourceFilter.forEach(function(filter, index) {
                if (filter.name === 'CDFILIAL' || filter.name === 'REPORT_NAME' || filter.name === 'TAMNIVEL' || filter.name === 'INIMES1' || filter.name === 'FINMES1' || filter.name === 'INIMES2' || filter.name === 'FINMES2' || filter.name === 'MES1' || filter.name === 'MES2') {
                    arrayIndex.push(index);
                }
            });
        }
        else {
            this.setShowOnlist(false, true, widget);
            if (!widget.dataSourceFilter.some(row => row.name == 'INIMES1'))
                widget.dataSourceFilter.push({
                    "name": "INIMES1",
                    "operator": "=",
                    "value": moment('01/' + widgetPopup.FILTER_ROW.MES1, 'DD/MM/YYYY').startOf('month').format('DD/MM/YYYY')
                });
            if (!widget.dataSourceFilter.some(row => row.name == 'FINMES1'))
                widget.dataSourceFilter.push({
                    "name": "FINMES1",
                    "operator": "=",
                    "value": moment('01/' + widgetPopup.FILTER_ROW.MES1, 'DD/MM/YYYY').endOf('month').format('DD/MM/YYYY')
                });
            if (!widget.dataSourceFilter.some(row => row.name == 'INIMES2'))
                widget.dataSourceFilter.push({
                    "name": "INIMES2",
                    "operator": "=",
                    "value": moment('01/' + widgetPopup.FILTER_ROW.MES2, 'DD/MM/YYYY').startOf('month').format('DD/MM/YYYY')
                });
            if (!widget.dataSourceFilter.some(row => row.name == 'FINMES2'))
                widget.dataSourceFilter.push({
                    "name": "FINMES2",
                    "operator": "=",
                    "value": moment('01/' + widgetPopup.FILTER_ROW.MES2, 'DD/MM/YYYY').endOf('month').format('DD/MM/YYYY')
                });
            widget.dataSourceFilter.forEach(function(filter, index) {
                if (filter.name === 'CDGRUPFILI' || filter.name === 'REPORT_NAME' || filter.name === 'TAMNIVEL' || filter.name === 'TIPOCUSTO' || filter.name === 'NMTIPOCUSTO' || filter.name === 'DATAINICIAL' || filter.name === 'DATAFINAL' || filter.name === 'MES1' || filter.name === 'MES2') {
                    arrayIndex.push(index);
                }
            });
        }

        this.buildDataSourceFilter(widget, arrayIndex);
        //voltar o valor do porduto final sem os Z no final
        for (var j = 0; j < widget.dataSourceFilter.length; j++) {
            if (widget.dataSourceFilter[j].name === 'CDPRODFINAL') {
                var newValue = widget.dataSourceFilter[j].value.split('z');
                widgetPopup.FILTER_ROW.CDPRODFINAL = newValue[0];
            }
        }
        widget.dataSourceFilter = widget.dataSourceFilter.filter(row => row.name != 'NMPRODINICIO' && row.name != 'NMPRODFINAL');

        widgetPopup.CUSTOM_FILTER_ROW = Util.clone(widgetPopup.FILTER_ROW);
        if (widgetPopup.CUSTOM_FILTER_ROW.hasOwnProperty('REPORT_NAME')) {
            delete widgetPopup.CUSTOM_FILTER_ROW.REPORT_NAME;
        }
        if (widgetPopup.CUSTOM_FILTER_ROW.hasOwnProperty('TAMNIVEL')) {
            delete widgetPopup.CUSTOM_FILTER_ROW.TAMNIVEL;
        }
        if (widgetPopup.CUSTOM_FILTER_ROW.hasOwnProperty('NMPRODINICIO')) {
            delete widgetPopup.CUSTOM_FILTER_ROW.NMPRODINICIO;
        }

        if (widgetPopup.CUSTOM_FILTER_ROW.hasOwnProperty('NMPRODFINAL')) {
            delete widgetPopup.CUSTOM_FILTER_ROW.NMPRODFINAL;
        }

        this.setLayout(args.owner);
        widget.activate().then(() => widget.reload());
    };

    this.buildDataSourceFilter = function(widget, indexs) {
        for (var i = indexs.length - 1; i >= 0; i--) {
            widget.dataSourceFilter.splice(indexs[i], 1);
        }
    };

    this.selectDataSourceByReport = function(widgetPopup) {
        var widget = templateManager.container.getWidget('dfe26000_inflacao_interna_grid');
        if (widgetPopup.FILTER_ROW.REPORT_NAME == 'Inflação Interna') {
            var dataSource26000 = "df_relatorios#/itlanctoest_inflacaointerna";
            widget.dataSource.name = dataSource26000;
        }
        else if (widgetPopup.FILTER_ROW.REPORT_NAME == 'Inflação de Compras') {
            var dataSource26001 = "df_relatorios#/itlanctoest_inflacaocompras";
            widget.dataSource.name = dataSource26001;
        }
        else if (widgetPopup.FILTER_ROW.REPORT_NAME == 'Inflação Interna Consolidada') {
            var dataSource26003 = "df_relatorios#/itlanctoest_inflacaointerna_consolidada";
            widget.dataSource.name = dataSource26003;
        }
        else {
            var dataSource26002 = "df_relatorios#/itlanctoest_inflcomprasmaisvol";
            widget.dataSource.name = dataSource26002;
        }
    };

    //onChange do campo REPORT_NAME do filtro
    this.setReadOnlyByReport = function(widgetPopup) {
        if (widgetPopup.getField('REPORT_NAME').value() == 'Inflação Interna') {
            widgetPopup.getField('DATAINICIAL').readOnly = true;
            widgetPopup.getField('DATAINICIAL').isVisible = false;
            if (!widgetPopup.getField('DATAINICIAL').validations)
                widgetPopup.getField('DATAINICIAL').validations = {};
            widgetPopup.getField('DATAINICIAL').validations.required = true;
            widgetPopup.getField('DATAINICIAL').setValue(moment().subtract(1, 'months').format("DD/MM/YYYY"));

            widgetPopup.getField('DATAFINAL').readOnly = true;
            widgetPopup.getField('DATAFINAL').isVisible = false;
            if (!widgetPopup.getField('DATAFINAL').validations)
                widgetPopup.getField('DATAFINAL').validations = {};
            widgetPopup.getField('DATAFINAL').validations.required = true;
            widgetPopup.getField('DATAFINAL').setValue(moment().format("DD/MM/YYYY"));

            widgetPopup.getField('NMTIPOCUSTO').readOnly = false;
            if (!widgetPopup.getField('NMTIPOCUSTO').validations)
                widgetPopup.getField('NMTIPOCUSTO').validations = {};
            widgetPopup.getField('NMTIPOCUSTO').validations.required = true;

            widgetPopup.getField('MES1').readOnly = false;
            widgetPopup.getField('MES1').isVisible = true;
            widgetPopup.getField('MES1').setValue(null);
            if (!widgetPopup.getField('MES1').validations)
                widgetPopup.getField('MES1').validations = {};
            if (widgetPopup.getField('MES1').validations.required)
                delete widgetPopup.getField('MES1').validations.required;

            widgetPopup.getField('MES2').readOnly = false;
            widgetPopup.getField('MES2').isVisible = true;
            widgetPopup.getField('MES2').setValue(null);
            if (!widgetPopup.getField('MES2').validations)
                widgetPopup.getField('MES2').validations = {};
            if (widgetPopup.getField('MES2').validations.required)
                delete widgetPopup.getField('MES2').validations.required;

            widgetPopup.getField('NMGRUPFILI').readOnly = true;
            widgetPopup.getField('NMGRUPFILI').setValue(null);
            if (!widgetPopup.getField('NMGRUPFILI').validations)
                widgetPopup.getField('NMGRUPFILI').validations = {};
            if (widgetPopup.getField('NMGRUPFILI').validations.required)
                delete widgetPopup.getField('NMGRUPFILI').validations.required;

            widgetPopup.getField('NMFILIAL').readOnly = false;
            if (!widgetPopup.getField('NMFILIAL').validations)
                widgetPopup.getField('NMFILIAL').validations = {};
            widgetPopup.getField('NMFILIAL').validations.required = true;

            if (widgetPopup.currentRow.$error) {
                widgetPopup.currentRow.$error.MES1 = [];
                widgetPopup.currentRow.$error.MES2 = [];
                widgetPopup.currentRow.$error.NMGRUPFILI = [];
            }

        }
        else if (widgetPopup.getField('REPORT_NAME').value() == 'Inflação Interna Consolidada') {
            widgetPopup.getField('DATAINICIAL').readOnly = false;
            widgetPopup.getField('DATAINICIAL').isVisible = true;
            if (!widgetPopup.getField('DATAINICIAL').validations)
                widgetPopup.getField('DATAINICIAL').validations = {};
            widgetPopup.getField('DATAINICIAL').validations.required = true;
            widgetPopup.getField('DATAINICIAL').setValue(moment().subtract(1, 'months').format("DD/MM/YYYY"));

            widgetPopup.getField('DATAFINAL').readOnly = false;
            widgetPopup.getField('DATAFINAL').isVisible = true;
            if (!widgetPopup.getField('DATAFINAL').validations)
                widgetPopup.getField('DATAFINAL').validations = {};
            widgetPopup.getField('DATAFINAL').validations.required = true;
            widgetPopup.getField('DATAFINAL').setValue(moment().format("DD/MM/YYYY"));

            widgetPopup.getField('NMTIPOCUSTO').readOnly = false;
            if (!widgetPopup.getField('NMTIPOCUSTO').validations)
                widgetPopup.getField('NMTIPOCUSTO').validations = {};
            widgetPopup.getField('NMTIPOCUSTO').validations.required = true;

            widgetPopup.getField('MES1').readOnly = true;
            widgetPopup.getField('MES1').isVisible = false;
            widgetPopup.getField('MES1').setValue(null);
            if (!widgetPopup.getField('MES1').validations)
                widgetPopup.getField('MES1').validations = {};
            if (widgetPopup.getField('MES1').validations.required)
                delete widgetPopup.getField('MES1').validations.required;

            widgetPopup.getField('MES2').readOnly = true;
            widgetPopup.getField('MES2').isVisible = false;
            widgetPopup.getField('MES2').setValue(null);
            if (!widgetPopup.getField('MES2').validations)
                widgetPopup.getField('MES2').validations = {};
            if (widgetPopup.getField('MES2').validations.required)
                delete widgetPopup.getField('MES2').validations.required;

            widgetPopup.getField('NMGRUPFILI').readOnly = false;
            if (!widgetPopup.getField('NMGRUPFILI').validations)
                widgetPopup.getField('NMGRUPFILI').validations = {};
            widgetPopup.getField('NMGRUPFILI').validations.required = true;


            widgetPopup.getField('NMFILIAL').readOnly = true;
            widgetPopup.getField('NMFILIAL').setValue(null);
            if (!widgetPopup.getField('NMFILIAL').validations)
                widgetPopup.getField('NMFILIAL').validations = {};
            if (widgetPopup.getField('NMFILIAL').validations.required)
                delete widgetPopup.getField('NMFILIAL').validations.required;


            if (widgetPopup.currentRow.$error) {
                widgetPopup.currentRow.$error.MES1 = [];
                widgetPopup.currentRow.$error.MES2 = [];
                widgetPopup.currentRow.$error.NMFILIAL = [];
            }

        }
        else {
            widgetPopup.getField('DATAINICIAL').readOnly = true;
            widgetPopup.getField('DATAINICIAL').isVisible = false;
            widgetPopup.getField('DATAINICIAL').setValue(null);
            if (!widgetPopup.getField('DATAINICIAL').validations)
                widgetPopup.getField('DATAINICIAL').validations = {};
            if (widgetPopup.getField('DATAINICIAL').validations.required)
                delete widgetPopup.getField('DATAINICIAL').validations;
            delete widgetPopup.currentRow.DTINICIAL;

            widgetPopup.getField('DATAFINAL').readOnly = true;
            widgetPopup.getField('DATAFINAL').isVisible = false;
            widgetPopup.getField('DATAFINAL').setValue(null);
            if (!widgetPopup.getField('DATAFINAL').validations)
                widgetPopup.getField('DATAFINAL').validations = {};
            if (widgetPopup.getField('DATAFINAL').validations.required)
                delete widgetPopup.getField('DATAFINAL').validations;
            delete widgetPopup.currentRow.DATAFINAL;

            widgetPopup.getField('NMTIPOCUSTO').readOnly = true;
            widgetPopup.getField('NMTIPOCUSTO').setValue(null);
            if (!widgetPopup.getField('NMTIPOCUSTO').validations)
                widgetPopup.getField('NMTIPOCUSTO').validations = {};
            if (widgetPopup.getField('NMTIPOCUSTO').validations.required)
                delete widgetPopup.getField('NMTIPOCUSTO').validations;

            widgetPopup.getField('MES1').readOnly = false;
            widgetPopup.getField('MES1').isVisible = true;
            if (!widgetPopup.getField('MES1').validations)
                widgetPopup.getField('MES1').validations = {};
            widgetPopup.getField('MES1').validations.required = true;
            widgetPopup.getField('MES2').readOnly = false;
            widgetPopup.getField('MES2').isVisible = true;
            if (!widgetPopup.getField('MES2').validations)
                widgetPopup.getField('MES2').validations = {};
            widgetPopup.getField('MES2').validations.required = true;

            widgetPopup.getField('NMGRUPFILI').readOnly = true;
            widgetPopup.getField('NMGRUPFILI').setValue(null);
            if (!widgetPopup.getField('NMGRUPFILI').validations)
                widgetPopup.getField('NMGRUPFILI').validations = {};
            if (widgetPopup.getField('NMGRUPFILI').validations.required)
                delete widgetPopup.getField('NMGRUPFILI').validations.required;

            widgetPopup.getField('NMFILIAL').readOnly = false;
            if (!widgetPopup.getField('NMFILIAL').validations)
                widgetPopup.getField('NMFILIAL').validations = {};
            widgetPopup.getField('NMFILIAL').validations.required = true;

            if (widgetPopup.currentRow.$error) {
                widgetPopup.currentRow.$error.DATAINICIAL = [];
                widgetPopup.currentRow.$error.DATAFINAL = [];
                widgetPopup.currentRow.$error.NMTIPOCUSTO = [];
                widgetPopup.currentRow.$error.NMGRUPFILI = [];
            }
        }
        this.setActionFLoatingControl(widgetPopup);
    };

    //onChange dos campos que seleciona lista ou todos, do filtro
    this.activeSelect = function(value, field) {
        field.setValue(field.value() || 'Todos');
        if (value == 'Lista') {
            field.readOnly = false;
            field.setValue(null);
            if (!field.filterProperties)
                field.filterProperties = {};
            field.filterProperties.validations = {};
            field.filterProperties.validations.required = true;
        }
        else {
            field.setValue(null);
            field.readOnly = true;
            delete field.filterProperties.validations.required;
            if (field.widget.currentRow.$error) {
                field.widget.currentRow.$error.NMTIPOOPER = [];
            }
        }
    };

    //onChange dos campos de datas, do filtro
    this.minMaxDate = function(minOrMax, date, field) {
        if (minOrMax == 'max') {
            field.maxDate = date;
        }
        else {
            field.minDate = date;
        }
    };

    this.validaNivel = function(currentRow, args) {
        if (currentRow.CDPRODINI && currentRow.CDPRODFINAL) {
            if (!General.comparaPratoProduto(currentRow.CDPRODINI, currentRow.CDPRODFINAL, getLocalVar('GER_CDPICTPROD'))) {
                ScreenService.showMessage("O Produto Final não pode ser maior que o Produto Inicial.");
                args.e.preventDefault();
                return true;
            }
        }
    };

    this.setShowOnlist = function(boolean1, boolean2, widget) {
        //Campos do relatorio Inflação Interna
        widget.getField('QTLANCTOEST').isVisible = boolean1;
        widget.getField('VRCUSTINIC').isVisible = boolean1;
        widget.getField('VRTOTAL').isVisible = boolean1;
        widget.getField('VRCUSTATUA').isVisible = boolean1;
        widget.getField('VRTOTAL2').isVisible = boolean1;

        //Campos do relatorio Inflação de Compras
        widget.getField('QTMES1').isVisible = boolean2;
        widget.getField('VRCUNIT1').isVisible = boolean2;
        widget.getField('VRMES1').isVisible = boolean2;
        widget.getField('QTMES2').isVisible = boolean2;
        widget.getField('VRCUNIT2').isVisible = boolean2;
        widget.getField('VRMES2').isVisible = boolean2;

        //Campos do relatorio Inflação Interna Consolidada
        widget.getField('MES_ANO').isVisible = false;
        widget.getField('CDFILIMOVI').isVisible = false;

        widget.resizeGridColumns(true);
    };

    this.setShowOnListConsolidada = function(widget) {

        //Campos do relatorio Inflação Interna

        widget.getField('VRTOTAL').isVisible = false;
        widget.getField('VRCUSTINIC').isVisible = true;
        widget.getField('VRTOTAL2').isVisible = false;

        //Campos do relatorio Inflação de Compras
        widget.getField('QTMES1').isVisible = false;
        widget.getField('VRCUNIT1').isVisible = false;
        widget.getField('VRMES1').isVisible = false;
        widget.getField('QTMES2').isVisible = false;
        widget.getField('VRCUNIT2').isVisible = false;
        widget.getField('VRMES2').isVisible = false;

        //Campos do relatorio Inflação Interna consolidada
        widget.getField('QTLANCTOEST').isVisible = true;
        widget.getField('CDFILIMOVI').isVisible = true;
        widget.getField('VRCUSTATUA').isVisible = true;
        widget.getField('MES_ANO').isVisible = true;
        
        widget.resizeGridColumns(true);
    };

    this.openFilterInflacao = function(args) {
        var inflacao_interna = templateManager.container.getWidget('dfe26000_inflacao_interna_grid');
        this.buildDataSorceIfMask(inflacao_interna.getField('TAMNIVEL'));
        var filterRow = {
            'NMTIPOCUSTO': 'Custo Médio Líquido Atual',
            'TIPOCUSTO': '1',
            'DATAFINAL': moment().format("DD/MM/YYYY"),
            'DATAINICIAL': moment().subtract(1, 'months').format("DD/MM/YYYY"),
            'CDPRODINI': null,
            'CDPRODFINAL': null,
            'CDOPERENTR': 'Todos',
            'NMPRODINICIO': null,
            'NMPRODFINAL': null,
            'REPORT_NAME': "Inflação Interna",
        };

        this.getFilialLogadaOperador().then(filialLogada => {
            var filial = filialLogada.dataset.filial[0];
            filterRow.NMFILIAL = filial.NMFILIAL;
            filterRow.CDFILIAL = filial.CDFILIAL;
            ZhFilterPreferences.setOriginalFilter(inflacao_interna.id, filterRow);
            ZhFilterPreferences.openFilterWidget(inflacao_interna, filterRow).then(() => {
                var popUp = templateManager.container.getActiveWidget('zhFilterPreferencesSelectConditions');
                this.setReadOnlyByReport(popUp);
            });

        });


    };

    this.buildDataSorceIfMask = function(field) {
        var levels = General.getLevelByMask("GER_CDPICTPROD", 1);
        for (var index in levels) {
            field.dataSource.data.push({
                "name": levels[index].nivel,
                "value": levels[index].nivel
            });
        }
    };

    this.generateReport = function(filterRow) {
        Dfe26000_InflacaoInterna_Service.generateReport(filterRow).then(function(birtURL) {
            window.open(birtURL.dataset.URL[0]);
        }, function(error) {
            ScreenService.showMessage(error.data.error);
        });
    };

    this.compararDatas = function(currentRow, args) {
        if (currentRow.REPORT_NAME != "Inflação Interna") {
            var dataInicial = moment(currentRow.MES1, "MM/YYYY");
            var dataFinal = moment(currentRow.MES2, "MM/YYYY");
            if (dataInicial.isAfter(dataFinal)) {
                ScreenService.showMessage('Comparativo Mês 1 deve ser menor que Mês 2.');
                args.e.preventDefault();
                return true;  
                
            }
        }
    };

    this.getFilialLogadaOperador = function() {
        var filter = [{
            "name": "CDFILIAL",
            "operator": "=",
            "value": "FILIAL_LOGADA"
        }];
        return General.callRestEngine('df#/crud/filial', 'FilterData', filter);
    };

    this.setActionFLoatingControl = function(popup) {
        var inflacao = templateManager.container.getWidget('dfe26000_inflacao_interna_grid');
        var action = inflacao.floatingControl.actions.filter(action => action.name === 'startBirt');
        if(popup.getField('REPORT_NAME').value() == 'Inflação Interna Consolidada'){
            action[0].icon = 'xls';
            action[0].label= "Relatório XLSX";
            inflacao.setAppliedLayout('');
        }
        else {
            action[0].icon = 'pdf';
            action[0].label= "Relatório PDF";
        }
    };

    this.setLayout = function(widget) {
        if (widget.filterData.REPORT_NAME == 'Inflação Interna Consolidada') {
            ZhLayoutPreferences.getWidgetLayouts(widget.id).then(layouts => {
                var layoutConsolidada = layouts.filter(layout => layout.ID === 'inflacaoInternaConsolidadaAgrupamentoDeFiliais');
                ZhLayoutPreferences.applyLayout(widget, layoutConsolidada[0]);
            });
        }
        else {
            ZhLayoutPreferences.applyOriginalLayout(widget);
        }
        
    };
    
};

Configuration(function(ContextRegister) {
    ContextRegister.register('Dfe26000_InflacaoInterna_Controller', Dfe26000_InflacaoInterna_Controller);
});
