var dfs49000_TransmissaoNfe_Repositories = function(localStorageEngine, restEngine) {
    this.montaConfigTransmissao = function(row) {
        var filter = [
            {
                "name": "ROW",
                "operator": "=",
                "value": row
            }
        ];
        return localStorageEngine.download("df#/config_transmissao", filter);
    };

    this.statusServico = function(notasfiscais, config) {
        var filter = [
            {
                "name": "NOTAS",
                "operator": "=",
                "value": notasfiscais
            },
            {
                "name": "CONFIG",
                "operator": "=",
                "value": config
            }
        ];
        return localStorageEngine.download("df_saida#/statusServico", filter);
    };

    this.transmiteNotas = function(notasfiscais, config, tipo) {
        var filter = [
            {
                "name": "NOTAS",
                "operator": "=",
                "value": notasfiscais
            },
            {
                "name": "CONFIG",
                "operator": "=",
                "value": config
            },
            {
                "name": "TIPO",
                "operator": "=",
                "value": tipo
            }
        ];
        return localStorageEngine.download("df_saida#/transmiteNotas", filter);
    };

    this.atualizaLote = function(lotesMarcados, config) {
        var filter = [
            {
                "name": "LOTESMARCADOS",
                "operator": "=",
                "value": lotesMarcados
            },
            {
                "name": "CONFIG",
                "operator": "=",
                "value": config
            }
        ];
        return localStorageEngine.download("df_saida#/atualizaLote", filter);
    };

    this.retornaDataProcessamento = function(filial) {
        var filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": filial
            }
        ];
        return localStorageEngine.download("df#/paramestoque_processamento", filter);
    };

    this.cancelarTransmissao = function(row, config) {
        var filter = [
            {
                "name": "ROW",
                "operator": "=",
                "value": row
            },
            {
                "name": "CONFIG",
                "operator": "=",
                "value": config
            }
        ];
        return localStorageEngine.download("df_saida#/cancelarTransmissao", filter);
    };

    this.enviarCartaCorrecao = function(notafiscal, dscorrecaonfe, nrseqcce, config) {
        var filter = [
            {
                "name": "NOTAFISCAL",
                "operator": "=",
                "value": notafiscal
            },
            {
                "name": "DSCORRECAONFE",
                "operator": "=",
                "value": dscorrecaonfe
            },
            {
                "name": "NRSEQCCE",
                "operator": "=",
                "value": nrseqcce
            },
            {
                "name": "CONFIG",
                "operator": "=",
                "value": config
            }
        ];
        return localStorageEngine.download("df_saida#/enviarCartaCorrecao", filter);
    };
    
    this.enviarEmailCC = function(notafiscal, config, tipo, nrseqcce) {
        var filter = [
            {
                "name": "NOTAFISCAL",
                "operator": "=",
                "value": notafiscal
            },
            {
                "name": "TIPO",
                "operator": "=",
                "value": tipo
            },
            {
                "name": "NRSEQCCE",
                "operator": "=",
                "value": nrseqcce
            },
            {
                "name": "CONFIG",
                "operator": "=",
                "value": config
            }
        ];
        return localStorageEngine.download("df_saida#/enviarEmailCC", filter);
    };

    this.visualizarDanfe = function(notasMarcadas, config) {
        var filter = [
            {
                "name": "NOTASMARCADAS",
                "operator": "=",
                "value": notasMarcadas
            },
            {
                "name": "CONFIG",
                "operator": "=",
                "value": config
            }
        ];
        return localStorageEngine.download("df_saida#/visualizarDanfe", filter);
    };

    this.downloadDanfe = function(notasMarcadas, config) {
        var filter = [
            {
                "name": "NOTASMARCADAS",
                "operator": "=",
                "value": notasMarcadas
            },
            {
                "name": "CONFIG",
                "operator": "=",
                "value": config
            }
        ];
        return localStorageEngine.download("df_saida#/downloadDanfe", filter);
    };

    this.downloadXML = function(notasMarcadas, config) {
        var filter = [
            {
                "name": "NOTASMARCADAS",
                "operator": "=",
                "value": notasMarcadas
            },
            {
                "name": "CONFIG",
                "operator": "=",
                "value": config
            }
        ];
        return localStorageEngine.download("df_saida#/downloadXML", filter);
    };

    this.enviarEmailPendenteNFsAceitas = function(notas, config) {
        var filter = [
            {
                "name": "NOTAS",
                "operator": "=",
                "value": notas
            },
            {
                "name": "CONFIG",
                "operator": "=",
                "value": config
            }
        ];
        return localStorageEngine.download("df_saida#/enviarEmailPendenteNFsAceitas", filter);
    };

    this.enviarEmailNF = function(nota, config, tipo) {
        var filter = [
            {
                "name": "NOTA",
                "operator": "=",
                "value": nota
            },
            {
                "name": "CONFIG",
                "operator": "=",
                "value": config
            },
            {
                "name": "TIPO",
                "operator": "=",
                "value": tipo
            }
        ];
        return localStorageEngine.download("df_saida#/enviarEmailNF", filter);
    };

    this.salvaProdutorRural = function(row) {
        return restEngine.post('df#/crud/nfprodrural/save', {
            "requestType": "Row",
            "row": row
        });
    };

    this.excluirProdutorRural = function(row) {
        return restEngine.post('df#/crud/nfprodrural/remove', {
            "requestType": "Row",
            "row": row
        });
    };

    this.getMaxNrseqcce = function(filial, lancamento){
        var filter = [
            {
                "name": "FILIAL",
                "operator": "=",
                "value": filial
            },
            {
                "name": "LANCAMENTO",
                "operator": "=",
                "value": lancamento
            }
        ];
        return localStorageEngine.download("df_saida#/maxNrseqcce", filter);
    };

    this.alteraDataEmissao = function(row) {
        return restEngine.post('df#/crud/notafiscal/save', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.requestModulesMetadata = () => {
        let modulesPackage = window.modulesPackage || "modules";
        return restEngine.requestMetaData(modulesPackage + "#json/modules.json").then(function (response) {
            return response.data;
        });
    };
};

Configuration(function(ContextRegister) {
    ContextRegister.register('Dfs49000_TransmissaoNfe_Repositories', dfs49000_TransmissaoNfe_Repositories);
});